Package com.emc.d2fs.interfaces

# Interface ISearchService

All Superinterfaces:
  `ID2fsService`

public interface ISearchService extends ID2fsService
Search and query management services. Below are values for search operators, fulltext operators and logical operators

Search Operators:

- equals
- is
- isNot
- notEquals
- contains
- beginWith
- endWith
- notContains
- isGreaterThan
- isGreaterOrEqualsThan
- isLessThan
- isLessOrEqualsThan

Fulltext Operators:

- any_words
- all_words
- exact_phrase
- without_words

Logical Operators:

- and
- or

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `FAST_SEARCH`
  Search type name - Fast search
  `static final String`
  `OPEN_SEARCH`
  Search type name - Open search
  `static final String`
  `SIMPLE_SEARCH`
  Search type name - Simple search
  `static final String`
  `XPLORE_SEARCH`
  Search type name - XPlore search

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `createSearchCategory(Context context, String objectName, String title, List<Attribute> attributes)`
  Create a search category.
  `String`
  `duplicateSearchAsLastSearch(Context context, String queryId)`
  Create a copy of a public or private search as the current users "last search"
  `SearchQueryTerm`
  `getLastSearchQueryTerm(Context context)`
  Get the last search definition
  `boolean`
  `getQuickSearchContent(Context context, String searchTerm)`
  Create a documentum search object into repository
  `boolean`
  `getQuickSearchContentWithOption(Context context, String searchTerm, List<Attribute> attributes)`
  Create a search object with option like current folder search or search on top of existing search
  `List<Option>`
  `getSearchAssistanceValues(Context context, List<String> searchTypes, String attribute, String filter)`
  Return a list of assistance values for the search attribute
  `List<Option>`
  `getSearchAttributes(Context context, List<String> searchTypes)`
  Return a list of searchable attributes based on the search types
  `List<Option>`
  `getSearchConditions(Context context, List<String> searchTypes, String attribute)`
  Return a list of search conditions for the search attribute
  `boolean`
  `getSearchMultiContent(List<Context> contexts, String searchTerm)`
  Create a documentum search object into multiple repository
  `List<Attribute>`
  `loadSearchAttributes(Context context, List<String> searchTypes)`
  Load search attributes
  `boolean`
  `runDQLSearch(Context context, List<Attribute> attributes)`
  Create a search using dql to custom search parameters
  `boolean`
  `runQueryFormSearch(Context context, String queryFormId, List<Attribute> attributes)`
  Create a search using query form to custom search parameters
  `boolean`
  `runTempDQLSearch(Context context, List<Attribute> attributes)`
  Create a search using dql to custom search parameters to fetch passed object
  `Node`
  `saveSearch(Context context, List<Attribute> attributes)`
  Save the search

  ### Methods inherited from interface com.emc.d2fs.interfaces.ID2fsService

  `isRemote, setRemote`

- ## Field Details

  - ### SIMPLE_SEARCH

    static final String SIMPLE_SEARCH
    Search type name - Simple search
    See Also:
      - Constant Field Values

  - ### FAST_SEARCH

    static final String FAST_SEARCH
    Search type name - Fast search
    See Also:
      - Constant Field Values

  - ### OPEN_SEARCH

    static final String OPEN_SEARCH
    Search type name - Open search
    See Also:
      - Constant Field Values

  - ### XPLORE_SEARCH

    static final String XPLORE_SEARCH
    Search type name - XPlore search
    See Also:
      - Constant Field Values

- ## Method Details

  - ### getQuickSearchContent

    boolean getQuickSearchContent(Context context, String searchTerm) throws Exception
    Create a documentum search object into repository
    Parameters:
      `context` - `Context` object containing informations about client/session
      `searchTerm` - String value of search term. If value is in quoted, search operator is "exact_phrase", otherwise, "any_words".
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### getQuickSearchContentWithOption

    boolean getQuickSearchContentWithOption(Context context, String searchTerm, List<Attribute> attributes) throws Exception
    Create a search object with option like current folder search or search on top of existing search
    Parameters:
      `context` -
      `searchTerms` - search term
      `attributes` - `Attribute` list of search parameters
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      16.3

  - ### getSearchMultiContent

    boolean getSearchMultiContent(List<Context> contexts, String searchTerm) throws Exception
    Create a documentum search object into multiple repository
    Parameters:
      `contexts` - `Context` list of object containing informations about client/session
      `searchTerm` - String value of search term.
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### runQueryFormSearch

    boolean runQueryFormSearch(Context context, String queryFormId, List<Attribute> attributes) throws Exception
    Create a search using query form to custom search parameters
    Parameters:
      `context` - `Context` object containing informations about client/session
      `queryFormId` - String value of query form id
      `attributes` - `Attribute` list of search parameters
      - config: DF_STRING, Search configuration name.
      - search_name: DT_STRING, (optional) Search name; default = "lastSearch"
      - list: DF_STRING, List of attribute names that contain search values (separated by AttributeUtils.SEPARATOR_VALUE)
      - Object Attribute: DF_STRING, Value for attribute or list of values (separated by AttributeUtils.SEPARATOR_VALUE). Each attribute name listed in "list".
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### getSearchAttributes

    List<Option> getSearchAttributes(Context context, List<String> searchTypes) throws Exception
    Return a list of searchable attributes based on the search types
    Parameters:
      `context` - `Context` object contains informations about client/session
      `searchTypes` - object contains the list of searchable types
    Returns:
      a list of searchable attributes
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### getSearchConditions

    List<Option> getSearchConditions(Context context, List<String> searchTypes, String attribute) throws Exception
    Return a list of search conditions for the search attribute
    Parameters:
      `context` - `Context` object contains informations about client/session
      `searchTypes` - object contains the list of searchable types
      `attribute` - object contains the name of the search attribute
    Returns:
      a list of search conditions
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### getSearchAssistanceValues

    List<Option> getSearchAssistanceValues(Context context, List<String> searchTypes, String attribute, String filter) throws Exception
    Return a list of assistance values for the search attribute
    Parameters:
      `context` - `Context` object contains informations about client/session
      `searchTypes` - object contains the list of searchable types
      `attribute` - object contains the name of the search attribute
      `filter` - string used as a filter
    Returns:
      a list of assistance values
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### loadSearchAttributes

    List<Attribute> loadSearchAttributes(Context context, List<String> searchTypes) throws Exception
    Load search attributes
    Parameters:
      `context` - `Context` object containing informations about client/session
    Returns:
      List of attributes
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### saveSearch

    Node saveSearch(Context context, List<Attribute> attributes) throws Exception
    Save the search
    Parameters:
      `context` - `Context` object containing informations about client/session
      `attributes` - `Attribute` list of search parameters
      - action: DF_STRING - Action to perform {run, save}
      - contentId: DF_STRING - Id of folder associated with or (node_saved_searches, node_saved_public_searches)
      - searched_types: DF_STRING - List of Documentum types to search (separated by AttributeUtils.SEPARATOR_VALUE)
      - all_versions: DF_BOOLEAN - Include all versions
      - hidden_objects: DF_BOOLEAN - Include hidden objects
      - is_filter: DF_BOOLEAN - Specify if filter is used
      - case_sensitive: DF_BOOLEAN - Specify if search is case sensitive
      - share_search: DF_BOOLEAN - Share search
      - wizard_search: DF_BOOLEAN - Specify if this is a wizard search. Selecting this query in D2 allows editing criteria before run.
      - overwrite: DF_BOOLEAN - Overwrite the existing saved search
      - is_asynchronous: DF_BOOLEAN - True to make search asynchronous
      - search_name: DF_STRING - Search name ("lastSearch" used for run action)
      - fulltext_operator: DF_STRING - Full text operator (any_words, all_words, exact_phrase, without_words)
      - fulltext_words: DF_STRING - Full text search terms
      - folder_path: DF_STRING - Folder path to restrict search (separated by AttributeUtils.SEPARATOR_VALUE)
      - folder_descend: DF_BOOLEAN - Descend folders in results
      - col_name: DF_STRING - Column/Type definition name (default="default") or list of column names (separated by AttributeUtils.SEPARATOR_VALUE)
      - facets: DF_STRING - List of query facets (separated by AttributeUtils.SEPARATOR_VALUE)
      - order_by: DF_STRING - Order results by attribute (default "score", order_by_direction="Desc")
      - order_by_direction: DF_STRING - Order by direction {"Desc", "Asc")

        The following lists make up the search expressions:

      - logical: DF_STRING - Logical operators (separated by AttributeUtils.SEPARATOR_VALUE)
      - bracket_open: DF_STRING - Determine if open bracket is present (separated by AttributeUtils.SEPARATOR_VALUE)
      - attr: DF_STRING - List of attribute names (separated by AttributeUtils.SEPARATOR_VALUE)
      - operator: DF_STRING - List of operators (separated by AttributeUtils.SEPARATOR_VALUE) (equals, is, isNot, notEquals, contains, beginWith, endWith, notContains, isGreaterThan, isGreaterOrEqualsThan, isLessThan, isLessOrEqualsThan)
      - attr_value: DF_STRING - List of attribute values (separated by AttributeUtils.SEPARATOR_VALUE)
      - bracket_close: DF_STRING - Determine if close bracket is present (separated by AttributeUtils.SEPARATOR_VALUE)
    Returns:
      Search Node
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### getLastSearchQueryTerm

    SearchQueryTerm getLastSearchQueryTerm(Context context) throws Exception
    Get the last search definition
    Parameters:
      `context` - `Context` object containing informations about client/session
    Returns:
      SearchQueryTerm `SearchQueryTerm` object
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### createSearchCategory

    String createSearchCategory(Context context, String objectName, String title, List<Attribute> attributes) throws Exception
    Create a search category.
    Parameters:
      `context` - `Context` object containing informations about client/session
      `objectName` - The name of the category (required)
      `title` - A title for the category.
      `attributes` - `Attribute` list of search parameters
    Returns:
      New category id
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### runDQLSearch

    boolean runDQLSearch(Context context, List<Attribute> attributes) throws Exception
    Create a search using dql to custom search parameters
    Parameters:
      `context` - `Context` object containing informations about client/session
      `attributes` - `Attribute` list of search parameters
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.2.1

  - ### runTempDQLSearch

    boolean runTempDQLSearch(Context context, List<Attribute> attributes) throws Exception
    Create a search using dql to custom search parameters to fetch passed object
    Parameters:
      `context` - `Context` object containing informations about client/session
      `attributes` - `Attribute` list of search parameters
    Returns:
      string - searchId
    Throws:
      `Exception`
    Since:
      4.8

  - ### duplicateSearchAsLastSearch

    String duplicateSearchAsLastSearch(Context context, String queryId) throws Exception
    Create a copy of a public or private search as the current users "last search"
    Parameters:
      `context` - `Context` object containing informations about client/session
      `queryId` - string containing the id of the query to duplicate
    Returns:
      string id of the newly created last search for this user
    Throws:
      `Exception`
    Since:
      4.2.1